#pragma once

#include <vector>

// Define um placar com um número limitado de scores maiores.
class Scoreboard {
  // INVARIANTE:
  // * _limit é o tamanho do placar (máximo número de scores guardados).
  // * _scores está ordenado do maior para o menor.
  // * Se não foram ainda inseridos mais do que _limit scores, todos os
  //   fornecidos estão em _scores.
  // * Se já foram inseridos mais do que _limit scores, os presentes em _scores
  //   são os maiores inseridos até o momento.
  std::vector<double> _scores;
  unsigned int const _limit;

public:
  // Constroi um placar com até limit maiores valores.
  Scoreboard(unsigned int limit);
  // Insere new_score, se for um dos maiores.
  void insert(double new_score);
  // Retorna os maiores scores registrados até o momento da chamada, do
  // maior para o menor.
  std::vector<double> largest_scores();
};
